#[derive(
    Debug,
    Clone,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    Default
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct SchemaName(pub String);
impl std::fmt::Display for SchemaName {
    fn fmt(&self, fmt: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        std::fmt::Display::fmt(&self.0, fmt)
    }
}
impl conjure_object::Plain for SchemaName {
    fn fmt(&self, fmt: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        conjure_object::Plain::fmt(&self.0, fmt)
    }
}
impl conjure_object::FromPlain for SchemaName {
    type Err = <String as conjure_object::FromPlain>::Err;
    #[inline]
    fn from_plain(s: &str) -> Result<SchemaName, Self::Err> {
        conjure_object::FromPlain::from_plain(s).map(SchemaName)
    }
}
impl std::convert::From<String> for SchemaName {
    #[inline]
    fn from(v: String) -> Self {
        SchemaName(std::convert::From::from(v))
    }
}
impl std::ops::Deref for SchemaName {
    type Target = String;
    #[inline]
    fn deref(&self) -> &String {
        &self.0
    }
}
impl std::ops::DerefMut for SchemaName {
    #[inline]
    fn deref_mut(&mut self) -> &mut String {
        &mut self.0
    }
}
impl std::convert::AsRef<String> for SchemaName {
    #[inline]
    fn as_ref(&self) -> &String {
        &self.0
    }
}
